require 'utility'

class Awsidprovider < ActiveRecord::Base
  belongs_to :awsaccount
  has_many   :awsrolemappings

  accepts_nested_attributes_for :awsrolemappings, reject_if: :all_blank, allow_destroy: true

  validates :arn, :presence => {message: 'You must supply a valid provider ARN.'}

  after_save    :after_save_callback
  after_destroy :after_destroy_callback


  # Return true if this SAML id provider ends in "saml-provider/stanford-idp"
  def regular_prod?()
    return arn =~ %r{saml-provider/stanford-idp$}
  end

#  # Return true if aws accounts file is due to be exported.
#  def self.should_aws_accounts_file_be_exported(force_update: false)
#    return Utility.should_file_be_exported(
#             filepath:           Awsaccount.awsaccounts_auto_file_path(),
#             updatedtime_name:   Awsrolemapping.awsrolemapping_updated_label(),
#             force_update:       force_update,
#             time_limit_seconds: 2 * 60 * 60,
#             action_label:       'awsrolemapping-changes'
#           )
#  end
#
#  # Update AWS accounts file (if necessary).
#  def self.maybe_write_accounts_file()
#    update_file = Awsidprovider.should_aws_accounts_file_be_exported()
#    if (update_file) then
#      Awsaccount.write_awsaccounts_auto_file()
#    end
#  end

  private

  def after_save_callback
    Utility.logger.info 'awsidprovider change detected; touching the updatedtimes table'
    Awsrolemapping.touch()
  end

  def after_destroy_callback
    Utility.logger.info 'awsidprovider object deleted; touching the updatedtimes table'
    Awsrolemapping.touch()
  end



end
